/*  magic_rain is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    magic_rain is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with magic_rain.  If not, see <http://www.gnu.org/licenses/>.

*/

#include <iostream>
#include <SFML/Graphics.hpp>
#include <time.h>
#include "rain.h"

#define W_WIDTH 600
#define W_HEIGHT 400

int main(int argc, char** argv)
{
	sf::RenderWindow window(sf::VideoMode(W_WIDTH,W_HEIGHT),"Magic Rain");
	srand(time(nullptr));

	short rain_density= 30;
	std::string mode="normal";

	if(argv[1]) rain_density = atoi(argv[1]);
	if(argv[2]) mode= argv[2];

	std::vector<rain> pioggia;
	float vel[3] {0.1,0.2,0.3};

	while(window.isOpen())
	{

		for(auto goccia=pioggia.begin(); goccia != pioggia.end(); ++goccia)
		{
			if((*goccia).getY() >= W_HEIGHT){
				 pioggia.erase(goccia);
				--goccia;
			}
		}

		if(rand()% rain_density == 0){
			 rain goccia((rand()%2)+1,rand()%20,rand()%W_WIDTH,0,vel);
			 pioggia.push_back(goccia);
		}

		sf::Event event;

		while(window.pollEvent(event))
		{
			if(event.type == sf::Event::Closed) window.close();
		}


	if(mode == "rainbow") window.clear(sf::Color(0x4b,0x00,0x82));
	else window.clear(sf::Color(0x6d,0x6d,0x6d));


	for(auto &goccia : pioggia)
	{
		goccia.draw(window);
		if(mode == "rainbow") goccia.changeRGB(rand()%255+1,rand()%255+1,rand()%255+1);
		goccia.move();
	}

	window.display();
	}

	return 0;
}
