/*  magic_rain is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    magic_rain is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with magic_rain.  If not, see <http://www.gnu.org/licenses/>.

*/

class rain
{


public:
	rain(int width, int height,int x, int y,float vel[])
	{
		_rain.setSize(sf::Vector2f(width,height));
		_rain.setPosition(x,y);
		_rain.setFillColor(sf::Color(this->R,this->G,this->B));
		this->vel=vel[(rand()%3)+1];
	}

	void move()
	{
		_rain.setPosition(_rain.getPosition().x,_rain.getPosition().y+this->vel*this->timer.getElapsedTime().asSeconds()+0.2);
	}

	void draw(sf::RenderWindow &window)
	{
		window.draw(_rain);
	}

	int getX()
	{
		return _rain.getPosition().x;
	}
	int getY()
	{
		return _rain.getPosition().y;
	}

	void changeRGB(short r,short g,short b)
	{
		_rain.setFillColor(sf::Color(r,g,b));

	}

private:
	float vel=0;
	short R=0x2f;
	short G=0x4f;
	short B=0x4f;
	sf::Clock timer;
	sf::RectangleShape _rain;
};
